<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:mvc="http://www.hyfinity.com/mvc" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">
		<WorkitemContext xmlns="">
			<xsl:apply-templates select="/mvc:eForm/mvc:Data/cached_wic/WorkitemContext">
				<xsl:with-param name="incomingWIC" select="/mvc:eForm/mvc:Data/WorkitemContext"/>
			</xsl:apply-templates>
		</WorkitemContext>
	</xsl:template>
	<xsl:template match="*">
		<xsl:param name="incomingWIC"/>
		<xsl:for-each select="*">
			<xsl:copy>
				<xsl:variable name="cachedCurrentNode" select="."/>
				<xsl:variable name="incomingMatchedNode" select="$incomingWIC/*[local-name(.)=local-name($cachedCurrentNode)]"/>
				<xsl:choose>
					<xsl:when test="normalize-space($incomingMatchedNode/text()) != ''">
						<xsl:value-of select="$incomingMatchedNode/text()"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$cachedCurrentNode/text()"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:apply-templates select=".">
					<xsl:with-param name="incomingWIC" select="$incomingMatchedNode"/>
				</xsl:apply-templates>
			</xsl:copy>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="ProcessVariables">
		<xsl:param name="incomingWIC"/>
		<xsl:copy-of select="$incomingWIC"/>
		<xsl:for-each select="ProcessVariable/*">
			<xsl:variable name="cachedCurrentNode" select="."/>
			<xsl:copy>
				<xsl:choose>
					<xsl:when test="local-name(.) = 'Value'">
						<xsl:variable name="incomingMatchedNode" select="$incomingWIC/*[local-name(.) = $cachedCurrentNode/../Name]"/>
						<xsl:choose>
							<xsl:when test="normalize-space($incomingMatchedNode/text()) != ''">
								<xsl:value-of select="$incomingMatchedNode/text()"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$cachedCurrentNode/text()"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$cachedCurrentNode/text()"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:copy>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>
